--[[
Copyright 2010 João Cardoso
Scrap Cleaner is distributed under the terms of the GNU General Public License (or the Lesser GPL).
This file is part of Scrap Cleaner.

Scrap Cleaner is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Scrap Cleaner is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Scrap Cleaner. If not, see <http://www.gnu.org/licenses/>.
--]]

hooksecurefunc('MainMenuBarBackpackButton_UpdateFreeSlots', function()
	if MainMenuBarBackpackButton.freeSlots == 0 then
		local bestValue, bestBag, bestSlot = 1/0
	
		for bag, slot, id in Scrap:IterateJunk() do
			local bagType = select(2, GetContainerNumFreeSlots(bag))
			
			if bagType == 0 then
				local maxStack = select(8, GetItemInfo(id))
				local stack = select(2, GetContainerItemInfo(bag, slot))
				local value = select(11, GetItemInfo(id)) * (stack + maxStack) * .5 -- Lets bet 50% on not full stacks
				
				if value < bestValue then
					bestBag, bestSlot = bag, slot
					bestValue = value
				end
			end
		end
		
		if bestBag and bestSlot then
			PickupContainerItem(bestBag, bestSlot)
			DeleteCursorItem()
		end
	end
end)